"
 Copyright (c) 2007-2010 Jan Vrany, SWING Research Group, Czech Technical University in Prague
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Tools }"

ApplicationModel subclass:#LintRuleDetail
	instanceVariableNames:'ruleHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Lint'
!

!LintRuleDetail class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2007-2010 Jan Vrany, SWING Research Group, Czech Technical University in Prague
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
! !

!LintRuleDetail class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:Tools::LintRuleDetail andSelector:#windowSpec
     Tools::LintRuleDetail new openInterface:#windowSpec
     Tools::LintRuleDetail open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'SmalllintRuleDetail'
          name: 'SmalllintRuleDetail'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 300 300)
        )
        component: 
       (SpecCollection
          collection: (
           (LabelSpec
              label: 'Name...'
              name: 'Name'
              layout: (LayoutFrame 0 0 0 0 0 1 30 0)
              translateLabel: true
              labelChannel: ruleNameAspect
              adjust: left
            )
           (DividerSpec
              name: 'Separator1'
              layout: (LayoutFrame 0 0 30 0 0 1 31 0)
            )
           (VerticalPanelViewSpec
              name: 'Panel'
              layout: (LayoutFrame 0 0 32 0 0 1 0 1)
              horizontalLayout: fit
              verticalLayout: topSpaceFit
              horizontalSpace: 0
              verticalSpace: 0
              component: 
             (SpecCollection
                collection: (
                 (HTMLViewSpec
                    name: 'Rationale'
                    level: 0
                    hasHorizontalScrollBar: true
                    hasVerticalScrollBar: true
                    htmlText: ruleRationaleAspect
                    extent: (Point 300 268)
                    postBuildCallback: setupHTMLView:
                  )
                 )
               
              )
            )
           )
         
        )
      )
! !

!LintRuleDetail class methodsFor:'plugIn spec'!

aspectSelectors
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this. If it is corrupted,
     the UIPainter may not be able to read the specification."

    "Return a description of exported aspects;
     these can be connected to aspects of an embedding application
     (if this app is embedded in a subCanvas)."

    ^ #(
        #ruleHolder
      ).

! !

!LintRuleDetail methodsFor:'aspects'!

ruleHolder
    "return/create the 'ruleHolder' value holder (automatically generated)"

    ruleHolder isNil ifTrue:[
        ruleHolder := ValueHolder new.
    ].
    ^ ruleHolder
!

ruleHolder:aValueModel
    "set the 'ruleHolder' value holder (automatically generated)"

    ruleHolder := aValueModel.
!

ruleNameAspect
    <resource: #uiAspect>

    |holder|

    (holder := builder bindingAt:#ruleNameAspect) isNil ifTrue:[
        holder := (AspectAdaptor forAspect: #displayString) subjectChannel: self ruleHolder.
        builder aspectAt:#ruleNameAspect put:holder.
"/       holder addDependent:self.
"/       holder onChangeSend:#ruleNameAspectChanged to:self.
    ].
    ^ holder.

    "Modified: / 05-02-2010 / 12:51:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ruleRationaleAspect
    <resource: #uiAspect>

    |holder|

    (holder := builder bindingAt:#ruleRationaleAspect) isNil ifTrue:[
        holder := (AspectAdaptor forAspect: #rationale) subjectChannel: self ruleHolder.
        builder aspectAt:#ruleRationaleAspect put:holder.
"/       holder addDependent:self.
"/       holder onChangeSend:#ruleRationaleAspectChanged to:self.
    ].
    ^ holder.

    "Modified: / 05-02-2010 / 12:51:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleDetail methodsFor:'initialization'!

setupHTMLView:aView
    aView painter 
        leftMargin:5;
        topMargin:5.

    "Created: / 04-08-2011 / 18:00:36 / cg"
! !

!LintRuleDetail class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/Tools__LintRuleDetail.st,v 1.3 2011-08-04 19:20:24 cg Exp $'
!

version_SVN
    ^ 'Id: Tools__LintRuleDetail.st 7617 2010-08-25 12:56:19Z vranyj1 '
! !
